
#include "jiti-recplay.h"
#include <pthread.h>  // voor intern gebruikte mutex


LCt _MR_thr_LC[MAXTHREADS];
LCt _MR_thr_LC_vorig[MAXTHREADS];
LCt _MR_thr_LOGS[ MAXTHREADS ][ LOGSPACE];
unsigned int _MR_thr_LOG_i[MAXTHREADS];
unsigned int _MR_thr_LOG_i_max[MAXTHREADS];
unsigned int _MR_thr_last_LC[MAXTHREADS];
unsigned int _MR_thr_first_LC[MAXTHREADS];

unsigned int _MR_thr_REPLAY_blocks[MAXTHREADS];

pthread_mutex_t  _MR_file_lock;

typedef FILE * fp;
fp _MR_fps_t;

unsigned int _MR_thr_LOG_lastb[MAXTHREADS];


/*************************************************************************/

void _MR_logLC(unsigned int tid, unsigned int from, unsigned int to);
void _MR_savelog(unsigned int tid);

/*************************************************************************/

void _MR_calc_lt(LCt * o_LC){
  LCt new;
  LCt * t_LC;
  unsigned tid = THREADID;
  LCt dummy=0;

  if (!o_LC) o_LC=&dummy;

  t_LC = &_MR_thr_LC[tid];

  new = max(*t_LC+1, *o_LC+1);

  if (new != *t_LC+1)
    _MR_logLC(tid, *t_LC, new);
    
  *t_LC = *o_LC = new;

}

/**************************************************************************/

void _MR_logLC(unsigned int tid, unsigned int from, unsigned int to){

  _MR_thr_LOGS[ tid ][ _MR_thr_LOG_i[ tid ]++ ] = from;
  _MR_thr_LOGS[ tid ][ _MR_thr_LOG_i[ tid ]++ ] = to;

  if ( _MR_thr_LOG_i[ tid ] == LOGSPACE ) 
    _MR_savelog( tid );
}

/************************************************************************/

void _MR_savelog( unsigned int tid ){
  unsigned int j,a,b,lastb;
  unsigned buffer[LOGSPACE*5/4];
  unsigned buffer_index;
  unsigned size;

  _MR_INTERN_mutex_lock(&_MR_file_lock);

#ifdef INCREMENT

  lastb = _MR_thr_LOG_lastb[ tid ];
  buffer_index = (unsigned)buffer;

  for (j=0; j<_MR_thr_LOG_i[ tid ]; j+=2){
    a=_MR_thr_LOGS[ tid ][ j ]   - lastb;
    b=_MR_thr_LOGS[ tid ][ j+1 ] - _MR_thr_LOGS[ tid ][ j ]-2;
    lastb=_MR_thr_LOGS[ tid ][ j+1 ];

    if (a<255) {
      *(unsigned char*)buffer_index++ = (unsigned char)a;
    } else {
      *(unsigned char*)buffer_index++ = (unsigned char)255;
      *(unsigned char*)buffer_index++ = (unsigned char)(a>>24);
      *(unsigned char*)buffer_index++ = (unsigned char)(a>>16);
      *(unsigned char*)buffer_index++ = (unsigned char)(a>>8);
      *(unsigned char*)buffer_index++ = (unsigned char)a;
    }
    
    if (b<255) {
      *(unsigned char*)buffer_index++ = (unsigned char)b;
    } else {
      *(unsigned char*)buffer_index++ = (unsigned char)255;
      *(unsigned char*)buffer_index++ = (unsigned char)(b>>24);
      *(unsigned char*)buffer_index++ = (unsigned char)(b>>16);
      *(unsigned char*)buffer_index++ = (unsigned char)(b>>8);
      *(unsigned char*)buffer_index++ = (unsigned char)b;
    }
    
  }

  size = buffer_index-(unsigned)buffer;

  if (size){
    fwrite(&tid, sizeof(int), 1, _MR_fps_t);                               /* tid */
    fwrite(&size, sizeof(int), 1, _MR_fps_t);                              /* count in bytes */
    fwrite(buffer, sizeof(char), size, _MR_fps_t);                         /* incr's */
  }
  _MR_thr_LOG_i[ tid ] = 0;  
  _MR_thr_LOG_lastb[ tid ] = lastb;

#else
  
  if (_MR_thr_LOG_i[tid]){
    unsigned size;
    fwrite(&tid, sizeof(int), 1, _MR_fps_t);                                 /* tid */
    size = _MR_thr_LOG_i[tid]*4;
    fwrite(&size, sizeof(int), 1, _MR_fps_t);                  /* count in bytes! */
    fwrite(_MR_thr_LOGS[tid], sizeof(int), _MR_thr_LOG_i[tid], _MR_fps_t);  /* LC's */
  }
  _MR_thr_LOG_i[ tid ] = 0;

#endif

  _MR_INTERN_mutex_unlock(&_MR_file_lock);

}

/*************************************************************************/

void _MR_start_record(){
  int i;
  char naam[100];
  
  // naam tracefile aanmaken
  sprintf(naam,"%s%s.%c", PREFIX, jiti_program_name(), 't'); 
  
  // naam tracefile opkuisen: vertaal / in _
  cleanup_file_name(naam);

  // open tracefile
  _MR_fps_t=fopen(naam,"w");
  
  // initialiseer alle laatste LCen op 0 ...
  for (i=0; i<MAXTHREADS ; i++)
    _MR_thr_LOG_lastb[ i ]=0;

  // ... en de LC v/d eerste draad op 1.
  _MR_thr_LC[1]=1;

  // Ready to go...

}

/************************************************************************/

void _MR_stop_record(){
  unsigned int i;
  FILE * fp;
  int aantal;
  char naam[100];
  long start, stop;

  // 'f' en 'l' wegschrijven
  {
    unsigned dummy;
    dummy=0;  /* Gebruik tid==0 */
    fwrite(&dummy, sizeof(int), 1, _MR_fps_t);
    dummy=MAXTHREADS*4*2; // in bytes
    fwrite(&dummy, sizeof(int), 1, _MR_fps_t);    
    fwrite(_MR_thr_first_LC, sizeof(int), MAXTHREADS, _MR_fps_t);   // 'f'
    fwrite(_MR_thr_LC, sizeof(int), MAXTHREADS, _MR_fps_t);         // 'l'
  }

  // Schrijf alle loginfo weg
  for (i=1; i<MAXTHREADS ; i++)
    _MR_savelog(i);

  fclose(_MR_fps_t);
  
}

/****************************************************/
