/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 *  trace-code.c 
 *
 *  Copyright (C) 2001 by Michiel Ronsse, Ghent University, Belgium
 *
 *  This file is part of JiTI86 (http://www.elis.rug.ac.be/~ronsse/jiti/)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 * $Author: ronsse $
 * $Date: 2001/10/25 13:46:01 $
 * $Log: trace-code.c,v $
 * Revision 1.2  2001/10/25 13:46:01  ronsse
 * Initial commit
 *
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 * This JiTI86 backend generates a list of instructions in the
 * order they are executed during a program run.
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include "jiti.h"


//////////////////////////////////////////////////

void _trace_code_trace(unsigned from, unsigned to){
  unsigned i=from;

  fprintf(jiti_tty, "C ? %.8x - %.8x\n", from, to);

  while(i<=to) {
    fprintf(jiti_tty, ">\t%.8x: ", i);
    i+=jiti_fprint_ins1(jiti_tty, 0, i);
    fprintf(jiti_tty, "\n");
  }
}         


//////////////////////////////////////////////////


_trace_code_init(){

  fprintf(jiti_tty, "===== TRACE-CODE: Trace all code accesses =====\n");

  jiti_callback("#CODE#", (unsigned)_trace_code_trace);
}


/////////////////////////////////////
             

INIT(_trace_code_init);
