/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 *  mmx.c 
 *
 *  Copyright (C) 2001 by Michiel Ronsse, Ghent University, Belgium
 *
 *  This file is part of JiTI86 (http://www.elis.rug.ac.be/~ronsse/jiti/)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 * $Author: ronsse $
 * $Date: 2002/02/28 12:24:14 $
 * $Log: mmx.c,v $
 * Revision 1.4  2002/02/28 12:24:14  ronsse
 * Merged updates from jmaebe branch, except the dynlib stuff.
 *
 * Revision 1.3.2.1  2002/02/27 18:05:35  jmaebe
 * * fixed wrong instruction lengths
 *
 * Revision 1.3  2001/10/25 13:46:01  ronsse
 * Initial commit
 *
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include "jiti.h"

extern unsigned char byte1, byte2, byte3, byte4, prefix_c, immsize_override;


unsigned _mmx(unsigned dummy1, unsigned dummy2, unsigned dummy3){
  unsigned char len, type, mod2;

  /* 
     Hier komen we terecht voor alle mmx-instructies, uitgezonderd
     EMMS, PSLL, PSRA en PSRL (zijn nooit geheugenoperaties). Deze
     laatste worden direct door no_mem() afgehandeld. 
  */

  /* shortcut naar de uitgang */
  mod2=byte2>>6;
  if (mod2==3)  return no_mem(2, 0, 0);          /* reg1, reg2 => 2 bytes + 0F-prefix counted in no_mem */

  /* type en lengte bepalen */
  type=LOAD,len=8;                      /* 64bits leesoperatie is default */
  if (byte1==0x7E) type=STORE,len=4;    /* movd schrijft 32bit */
  if (byte1==0x7F) type=STORE;          /* movq schrijft (64bit) */

  return check_mod(0, len, type);

}
