/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 *  par.c 
 *
 *  Copyright (C) 2001 by Michiel Ronsse, Ghent University, Belgium
 *
 *  This file is part of JiTI86 (http://www.elis.rug.ac.be/~ronsse/jiti/)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 * $Author: ronsse $
 * $Date: 2001/10/29 13:53:56 $
 * $Log: par.c,v $
 * Revision 1.4  2001/10/29 13:53:56  ronsse
 * JiTI is locked using jiti_lock() during the creation of a new thread. This seems
 * to remove the SEGV faults.
 *
 * Revision 1.3  2001/10/25 13:46:01  ronsse
 * Initial commit
 *
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


#include "jiti.h"
#include <semaphore.h>


extern int _jiti_par_exec, _jiti_par_program;

int (*real_pthread_create)(pthread_t *, const pthread_attr_t *, void * (*)(void *), void *);

///////////////////////

int jiti_pthread_create(pthread_t * thread, const pthread_attr_t * attr, 
		void * (*start_routine)(void *), void * arg){
  int status;	

  jiti_lock();
  _jiti_par_exec=1; // de parallelle uitvoering is gestart!
  
  // Merk op: dit werkt met en zonder cloon!   
  status = (*real_pthread_create)(thread, attr, start_routine+delta, arg);
  jiti_unlock();

  return status;
}

///////////////////////

void par_init(){
  if ((real_pthread_create = (int(*)(pthread_t *, const pthread_attr_t *, void * (*)(void *), void *))
       jiti_callback("pthread_create", (unsigned)jiti_pthread_create))) {
    _jiti_par_program=1;
    DBG(fprintf(jiti_tty, "PAR\n"));
  } else {
    DBG(fprintf(jiti_tty, "SEQ\n"));
    _jiti_par_program=0;    
  }
}

//////////////////////
