/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 *  plt.c 
 *
 *  Copyright (C) 2001 by Michiel Ronsse, Ghent University, Belgium
 *
 *  This file is part of JiTI86 (http://www.elis.rug.ac.be/~ronsse/jiti/)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 * $Author: ronsse $
 * $Date: 2002/02/28 12:24:14 $
 * $Log: plt.c,v $
 * Revision 1.4  2002/02/28 12:24:14  ronsse
 * Merged updates from jmaebe branch, except the dynlib stuff.
 *
 * Revision 1.3.2.1  2002/02/25 16:25:17  jmaebe
 * + deactivate jiti when exit() is called too (fixes crash at the end of gzip)
 *
 * Revision 1.3  2001/10/25 13:46:01  ronsse
 * Initial commit
 *
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


#include <stdlib.h> // voor malloc()
#include "jiti.h"


typedef struct _plt_info_t {
  char name[100];
  unsigned plt_address;
  struct _plt_info_t * next;
} plt_info_t;

plt_info_t __plt_info={
  "--",
  0,
  NULL
};

plt_info_t * plt_info = &__plt_info;

//////////////////////////////

void add_to_plt(char * name, unsigned plt_address){
  plt_info_t * plt_new, * plt_runner = plt_info;

  // loop tot het einde
  while (plt_runner->next)
    plt_runner=plt_runner->next;

  // toevoegen
  plt_new=(plt_info_t*)malloc(sizeof(plt_info_t));
  strcpy(plt_new->name, name);
  plt_new->plt_address  = plt_address;
  plt_new->next         = NULL;

  // aanhangen
  plt_runner->next=plt_new;

}

//////////////////////////////

unsigned intercept_plt(char * name, unsigned new_target){
  unsigned old_target;
  plt_info_t * plt_runner = plt_info;
  
  
  while (strcmp(plt_runner->name, name))
    if (!plt_runner->next) {
      DBG(printf("%s not found!\n", name));
      return 0;    // niet gevonden
    } else
      plt_runner=plt_runner->next;
  
  old_target = *(unsigned*)(plt_runner->plt_address);

  // PLT wijzigen
  DBG(printf("Writing %x at %x\n", new_target, plt_runner->plt_address));
  *(unsigned*)plt_runner->plt_address=new_target;


  // echt adres teruggeven
  return old_target;
}

//////////////////////////////

unsigned get_exit_jmpaddr(void) {
  plt_info_t * plt_runner = plt_info;

  while (strcmp(plt_runner->name, "exit"))
    if (!plt_runner->next) {
      DBG(printf("'exit' not found!\n"));
      return 0;    // niet gevonden
    } else
      plt_runner=plt_runner->next;
  
  return *(unsigned*)plt_runner->plt_address;
}

//////////////////////////////

