//////////////////////////////////////////////////////////////////////////////////
//
//  spinclock.s 
//
//  Copyright (C) 2001 by Michiel Ronsse, Ghent University, Belgium
//
//  This file is part of JiTI86 (http://www.elis.rug.ac.be/~ronsse/jiti/)
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
//
//////////////////////////////////////////////////////////////////////////////////
//
// $Author: ronsse $
// $Date: 2001/11/14 14:04:49 $
// $Log: spinlock.s,v $
// Revision 1.4  2001/11/14 14:04:49  ronsse
// Changed /* to // type of comments in copyright notice.
//
// Revision 1.3  2001/10/25 13:46:01  ronsse
// Initial commit
//
//////////////////////////////////////////////////////////////////////////////////



.include "macros.inc"
	
	
.text
        .align 4

	
/////////////////////////////////////////////////////////////////////////////////////
			
.globl __wait_and_set
        .type range,@function
	
__wait_and_set:

	// 1 argument:	 adres v/d spinlock
	
	pushl %ebp
	movl %esp, %ebp
	pushl %eax
	pushl %ebx
	pushf
	
	// haal het argument binnen -> %eax
	movl 8(%ebp), %eax

	
again:
	// initialiseer de te schrijven waarde
	movl $1, %ebx

	// lock prefix
	.byte 0xF0
	xchgl (%eax),%ebx
	cmpl $1, %ebx
	je again
	
done:	
	
	popf	
	popl %ebx
	popl %eax
	leave
	ret
	
	.size __wait_and_set,.-__wait_and_set

