//////////////////////////////////////////////////////////////////////////////////
//
//  stack.s 
//
//  Copyright (C) 2001 by Michiel Ronsse, Ghent University, Belgium
//
//  This file is part of JiTI86 (http://www.elis.rug.ac.be/~ronsse/jiti/)
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
//
//////////////////////////////////////////////////////////////////////////////////
//
// $Author: ronsse $
// $Date: 2001/11/14 14:04:49 $
// $Log: stack.s,v $
// Revision 1.4  2001/11/14 14:04:49  ronsse
// Changed /* to // type of comments in copyright notice.
//
// Revision 1.3  2001/10/25 13:46:01  ronsse
// Initial commit
//
//
//////////////////////////////////////////////////////////////////////////////////


.include "macros.inc"


.text
        .align 4


/////////////////////////////////////////////////////////////////////////////////////

.globl print_my_stack
        .type print_my_stack, @function

	///////////////////////////////////
	//
	// print_my_stack(op_to_roepen_functie_voor_elk_stackframe, te_skippen_frames)
	//
	// op_to_roepen_functie_voor_elk_stackframe krijgt als argument IP mee, en moet
	// 1 teruggeven indien we een volgend stackframe nodig hebben.
	//
	//  VB:	
	//
	//	unsigned ip2source(unsigned ip){
	//	  if (ip>0x40000000) return 0; // 't is gedaan, we zijn in jiti gearriveerd
	//	  jiti_addr2line(ip);
	//	  return 1;  // op naar het volgende frame
	//	}
	//
	//	print_my_stack(ip2source, 3) ; 
	//
	////////////////////////////////////
	
print_my_stack:
	push %ebp
	movl %esp, %ebp
	
	// argument 2: te skippen stackframes
	movl 12(%ebp), %ecx
	
	// argument 1: op te roepen functie
	movl 8(%ebp), %edx
	
	movl %ebp, %ebx

	cmpl $0, %ecx
	je   .noskip
	
// skippen van %ecx frames
.skip:	
	movl (%ebx), %ebx
	loop .skip		

.noskip:	
		
// vanaf nu kunnen we frames dumpen
.again:
	leal 4(%ebx), %eax
	movl (%eax), %eax
	subl $5, %eax
	pushl %eax
	call *8(%ebp)
	addl $4, %esp

	cmpl $1, %eax
	jne .done
	// opnieuw??
	movl (%ebx), %ebx
	jmp .again
	
.done:	
	
	leave
        ret	

        .size print_my_stack,.-print_my_stack

	////////////////////////////////////////////////
	//
	// get_ip() retourneert de IP v/d oproeper v/d oproeper van get_ip
	//
	////////////////////////////////////////////////
.globl get_ip
	.type 	get_ip, @function
get_ip:	
	movl 4(%ebp), %eax
	ret
			
	.size get_ip,.-get_ip

